<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
</head>
<body>
    <div id="maze"></div>
<style>
    #maze {
        width: 640px;
        height: 480px;
        margin: auto;
        position: relative;
        border: 1px solid black;
    }
    .room:hover {
        opacity: 0.5;
    }
    .room > div {
        display: flex;
        justify-content: center;
        align-items: center;
        flex-flow: column;
        z-index: 0;
        color: white;
        border: 1px solid magenta;
    }
    .room > div > div {
        background: rgba(255, 0, 255, 0.9);
        position: absolute;
        left: 0;
        right: 0;
        top: 0;
        bottom: 0;
        z-index: -1;
    }
    .cell {
        background: #ccc;
    }
    .door {
        pointer-events: none;
    }
    .door div {
        background: gray;
        color: white;
        font-size: 8px;
        font-weight: bold;
        display: flex;
        justify-content: center;
        align-items: center;
    }
    .room > .group-1 {
        border-color: #f00;
    }
    .room > .group0 {
        border-color: #f00;
    }
    .room > .group1 {
        border-color: #ff0;
    }
    .room > .group2  {
        border-color: #0f0;
    }
    .room > .group3  {
        border-color: #00f;
    }
    .room > .group4  {
        border-color: #000;
    }
    .room span:not(:first-child) {
        font-size: small;
    }
    .room > div.cave > div {
        background: rgba(20, 20, 0, 0.9);
    }
    .room > div.city > div {
        background: rgba(20, 20, 100, 0.9);
    }
    .room > div.sewers > div {
        background: rgba(100, 50, 0, 0.9);
    }
    .room > div.forest > div {
        background: rgba(50, 100, 0, 0.9);
    }
    .room > div.graveyard > div {
        background: rgba(100, 100, 100, 0.9);
    }
    .room > div.hive > div {
        background: rgba(190, 100, 0, 0.9);
    }
</style>
<script src="random.js"></script>
<script src="maze.js"></script>
<script src="maze_items.js"></script>
<script src="environment.js"></script>
<script>
var maze = new Maze(document.getElementById("maze"), 16);
maze.random.prng.seed(0);
var start_room = new Room(4, 0, 8, 4, maze.random);
maze.add_room(start_room);
maze.seed(new Door(3, 3, 4, 3, ""));
maze.fill_maze();
maze.fill_doors();
maze.lock_doors(start_room, -1, 1);
maze.lock_doors(start_room, 0, 15);
maze.lock_doors(start_room, 1, 30);
maze.lock_doors(start_room, 2, 45);
maze.lock_doors(start_room, 3, 60);
maze.lock_doors(start_room, 4, 999);

maze.annotate_distance([start_room], "distance");
var item_rooms = [start_room];

function add_item(name, min, max)
{
    var item_room = maze.room_for_item(item_rooms, min, max);
    item_room.items.push(name);
    item_rooms.push(item_room);
}

start_room.items.push("START");
start_room.items.push("rest");

for ( var i = 0; i < 3; i++ )
    add_item("end_key", null, null);

for ( var i = 0; i < 4; i++ )
    add_item(`key_${i+1}`, i, i);

for ( var i = 0; i < 3; i++ )
    add_item(`upgrade_${i+1}`, i+1, i+1);

for ( var i = 0; i < 4; i++ )
    for ( var j = 0; j < 2; j++ )
        add_item("rest", i, i);

for ( var i = 0; i < 4; i++ )
    for ( var j = 0; j < 2; j++ )
        add_item("bonus", i, i);

let envs = [
    new CaveEnvironment(0.8),
    new CityEnvironment(0.9, 4),
    new HiveEnvironment(0.9, 2),
    new SewersEnvironment(0.9, 0),
    new GraveyardEnvironment(0.8, 0),
    new ForestEnvironment(0.8, 3),
]
start_room.environment = envs[1];
maze.apply_environments(envs);
maze.calculate_areas();
maze.render(true);


console.log("%cEnvironments", "font-weight: bold");
for ( let env of envs )
    console.log(env.name, env.rooms.length);

console.log("%cAreas", "font-weight: bold");
for ( let area of maze.areas )
    console.log(area.tag, area.rooms.length);

</script>
</body>
</html>
